jj-diff(1)

NAME
jj-diff - Compare file contents between two revisions

SYNOPSIS
jj diff [-r|--revisions] [-R|--repository] [-f|--from] [--ignore-working-copy] [--no-integrate-operation] [-t|--to] [--ignore-immutable] [-T|--template] [--at-operation] [-s|--summary] [--debug] [--stat] [--color] [--types] [--name-only] [--quiet] [--git] [--no-pager] [--color-words] [--config] [--config-file] [--tool] [--context] [-w|--ignore-all-space] [-b|--ignore-space-change] [-h|--help] [FILESETS]

DESCRIPTION
Compare file contents between two revisions

With the `-r` option, shows the changes compared to the parent revision. If there are several parent revisions (i.e., the given revision is a merge), then they will be merged and the changes from the result to the given revision will be shown.

With the `--from` and/or `--to` options, shows the difference from/to the given revisions. If either is left out, it defaults to the working-copy commit. For example, `jj diff --from main` shows the changes from "main" (perhaps a bookmark name) to the working-copy commit.

If no option is specified, it defaults to `-r @`.

OPTIONS

-r, --revisions <REVSETS>
    Show changes in these revisions If there are multiple revisions, then the total diff for all of them will be shown. For example, if you have a linear chain of revisions A..D, then `jj diff -r B::D` equals `jj diff --from A --to D`. Multiple heads and/or roots are supported, but gaps in the revset are not supported (e.g. `jj diff -r 'A|C'` in a linear chain A..C). If a revision is a merge commit, this shows changes *from* the automatic merge of the contents of all of its parents *to* the contents of the revision itself. If none of `-r`, `-f`, or `-t` is provided, then the default is `-r @`.

-f, --from <REVSET>
    Show changes from this revision If none of `-r`, `-f`, or `-t` is provided, then the default is `-r @`.

-t, --to <REVSET>
    Show changes to this revision If none of `-r`, `-f`, or `-t` is provided, then the default is `-r @`.

-h, --help
    Print help (see a summary with '-h')

[FILESETS]
    Restrict the diff to these paths

DIFF FORMATTING OPTIONS

-T, --template <TEMPLATE>
    Render each file diff entry using the given template All 0-argument methods of the [`TreeDiffEntry` type] are available as keywords in the template expression. See [`jj help -k templates`] for more information. [`TreeDiffEntry` type]: https://docs.jj-vcs.dev/latest/templates/#treediffentry-type [`jj help -k templates`]: https://docs.jj-vcs.dev/latest/templates/

-s, --summary
    For each path, show only whether it was modified, added, or deleted

--stat
    Show a histogram of the changes

--types
    For each path, show only its type before and after The diff is shown as two letters. The first letter indicates the type before and the second letter indicates the type after. '-' indicates that the path was not present, 'F' represents a regular file, `L' represents a symlink, 'C' represents a conflict, and 'G' represents a Git submodule.

--name-only
    For each path, show only its path Typically useful for shell commands like: `jj diff -r @- --name-only | xargs perl -pi -e's/OLD/NEW/g`

--git
    Show a Git-format diff

--color-words
    Show a word-level diff with changes indicated only by color

--tool <TOOL>
    Generate diff by external command A builtin format can also be specified as `:<name>`. For example, `--tool=:git` is equivalent to `--git`.

--context <CONTEXT>
    Number of lines of context to show

-w, --ignore-all-space
    Ignore whitespace when comparing lines

-b, --ignore-space-change
    Ignore changes in amount of whitespace when comparing lines

GLOBAL OPTIONS

-R, --repository <REPOSITORY>
    Path to repository to operate on By default, Jujutsu searches for the closest .jj/ directory in an ancestor of the current working directory.

--ignore-working-copy
    Don't snapshot the working copy, and don't update it By default, Jujutsu snapshots the working copy at the beginning of every command. The working copy is also updated at the end of the command, if the command modified the working-copy commit (`@`). If you want to avoid snapshotting the working copy and instead see a possibly stale working-copy commit, you can use `--ignore-working-copy`. This may be useful e.g. in a command prompt, especially if you have another process that commits the working copy. Loading the repository at a specific operation with `--at-operation` implies `--ignore-working-copy`.

--no-integrate-operation
    Run the command as usual but don't integrate any operations When this option is given, the operations will still be created as usual but they will not be integrated to the operation log. The working copy will also not be updated. The command will print the resulting operation ID. You can pass that to e.g. `jj --at-op` to inspect the resulting repo state, or you can pass it to `jj op restore` to restore the repo to that state. You can also pass the ID to `jj op integrate` to integrate the operation. Note that this does *not* prevent side effects outside the repo. For example, `jj git push --no-integrate-operation` will still perform the push.

--ignore-immutable
    Allow rewriting immutable commits By default, Jujutsu prevents rewriting commits in the configured set of immutable commits. This option disables that check and lets you rewrite any commit but the root commit. This option only affects the check. It does not affect the `immutable_heads()` revset or the `immutable` template keyword.

--at-operation <AT_OPERATION>
    Operation to load the repo at Operation to load the repo at. By default, Jujutsu loads the repo at the most recent operation, or at the merge of the divergent operations if any. You can use `--at-op=<operation ID>` to see what the repo looked like at an earlier operation. For example `jj --at-op=<operation ID> st` will show you what `jj st` would have shown you when the given operation had just finished. `--at-op=@` is pretty much the same as the default except that divergent operations will never be merged. Use `jj op log` to find the operation ID you want. Any unambiguous prefix of the operation ID is enough. When loading the repo at an earlier operation, the working copy will be ignored, as if `--ignore-working-copy` had been specified. It is possible to run mutating commands when loading the repo at an earlier operation. Doing that is equivalent to having run concurrent commands starting at the earlier operation. There's rarely a reason to do that, but it is possible.

--debug
    Enable debug logging

--color <WHEN>
    When to colorize output
    Possible values:

    •   always

    •   never

    •   debug

    •   auto

--quiet
    Silence non-primary command output For example, `jj file list` will still list files, but it won't tell you if the working copy was snapshotted or if descendants were rebased. Warnings and errors will still be printed.

--no-pager
    Disable the pager

--config <NAME=VALUE>
    Additional configuration options (can be repeated) The name should be specified as TOML dotted keys. The value should be specified as a TOML expression. If string value isn't enclosed by any TOML constructs (such as array notation), quotes can be omitted.

--config-file <PATH>
    Additional configuration files (can be repeated)